package com.bcb.master.adapter

import android.content.Context
import android.content.Intent
import android.view.View
import android.view.ViewGroup
import android.widget.BaseExpandableListAdapter
import android.widget.ImageView
import android.widget.TextView
import com.bcb.master.R
import com.bcb.master.clicke.BaseClickToPagerUtils
import com.bcb.master.model.ContactSeriviceQuestionBean
import com.bcb.master.ui.FeedbackDetailActivity
import org.jetbrains.anko.startActivity

class ContactSerivceAdapter(mArray: ArrayList<ContactSeriviceQuestionBean>, context: Context) : BaseExpandableListAdapter() {
    var array: ArrayList<ContactSeriviceQuestionBean>
    val mContext: Context

    init {
        this.mContext = context
        this.array = mArray
    }

    override fun getGroup(groupPosition: Int): Any {
        return array[groupPosition]
    }

    /**
     * 子列表是否可选中
     */
    override fun isChildSelectable(groupPosition: Int, childPosition: Int): Boolean {
        return true
    }

    override fun hasStableIds(): Boolean {
        return false
    }

    override fun getGroupView(groupPosition: Int, isExpanded: Boolean, convertView: View?, parent: ViewGroup?): View {
        var holderGroup: ViewHolderGroup
        var view:View
        if (convertView == null) {
            view = View.inflate(mContext,R.layout.item_contactservice_title1, null);
            holderGroup = ViewHolderGroup(view)
            view.setTag(holderGroup)
        } else {
            view= convertView
            holderGroup = view.getTag() as ViewHolderGroup
        }
        holderGroup.tv_title1.setText(array[groupPosition].title)
        holderGroup.iv_icon.setImageResource(array[groupPosition].imgres)
        if (isExpanded)
        {
           holderGroup.iv_right.visibility=View.GONE
        }else{
            holderGroup.iv_right.visibility = View.VISIBLE
        }
        return view
    }

    override fun getChildrenCount(groupPosition: Int): Int {
        return array[groupPosition].items.size
    }

    override fun getChild(groupPosition: Int, childPosition: Int): Any {
        return array[groupPosition].items[childPosition]
    }

    override fun getGroupId(groupPosition: Int): Long {
        return groupPosition.toLong()
    }

    override fun getChildView(groupPosition: Int, childPosition: Int, isLastChild: Boolean, convertView: View?, parent: ViewGroup?): View {
        var view :View
        var holderGroup: ViewHolderItem
        if (convertView == null) {
            view = View.inflate(mContext,R.layout.item_contactservice_title2, null);
            holderGroup = ViewHolderItem(view)
            view.setTag(holderGroup)
        } else {
            view = convertView
            holderGroup = view.getTag() as ViewHolderItem
        }
        view.setOnClickListener{

            val datares = array[groupPosition].items[childPosition].datares
            val data = mContext.resources.getString(datares)
            if (data.startsWith("http"))
            {
                BaseClickToPagerUtils(mContext,data).onClick(null)
            }else{
                val intent = Intent(mContext, FeedbackDetailActivity::class.java)
                intent.putExtra("title",array[groupPosition].items[childPosition].title)
                intent.putExtra("datares",datares)
                mContext.startActivity(intent)
            }

        }
        holderGroup.tv_title1.setText(array[groupPosition].items[childPosition].title)
        return view
    }

    override fun getChildId(groupPosition: Int, childPosition: Int): Long {
        return childPosition.toLong()
    }

    override fun getGroupCount(): Int {
        return array.size
    }

    private class ViewHolderGroup(view: View) {
        var tv_title1: TextView = view.findViewById(R.id.tv_title1) as TextView
        var iv_icon: ImageView = view.findViewById(R.id.iv_icon) as ImageView
        var iv_right: ImageView = view.findViewById(R.id.iv_right) as ImageView
    }
 private class ViewHolderItem(view: View) {
        var tv_title1: TextView = view.findViewById(R.id.tv_title1) as TextView
    }

}