package com.bcb.master.adapter

import com.bcb.master.R
import com.bcb.master.utils.TimeUtil
import com.blankj.utilcode.util.TimeUtils
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.loopj.http.entity.QXQQuestionListBean

class QuestionVideoListAdapter() : BaseQuickAdapter<QXQQuestionListBean.VideoQuestionItem, BaseViewHolder>(R.layout.item_video_question) {
    override fun convert(helper: BaseViewHolder, item: QXQQuestionListBean.VideoQuestionItem) {
        helper.setText(R.id.tv_question, item.content)
        helper.setText(R.id.tv_time, TimeUtils.millis2String(item.create_time!!.toLong() * 1000, "yyyy年MM月dd日 HH:mm"))
        var status = "追问中"
        when (item.process_status) {
            "unanswered" -> {
                status = "未回答"
            }
            "answered" -> {
                status = "追问中"
            }
            "wait_comment" -> {
                status = "待评价"
            }
            "commented" -> {
                status = "已评价"
            }
        }
        when (item.closed_status)
        {
            "Y"->{
                status = "已关闭"
            }
        }
        var price  = item.price;
        helper.setText(R.id.tv_question_state,status)
        helper.setText(R.id.tv_price,"¥$price")
    }
}