package com.bcb.master.ui

import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.widget.EditText
import android.widget.ImageView
import android.widget.TextView
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import com.bcb.master.AppConstants
import com.bcb.master.MasterApplication
import com.bcb.master.R
import com.bcb.master.utils.HintKb
import com.bcb.master.utils.ToastUtils
import com.loopj.http.bcb.CMHttpSender
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.entity.ChangeCommonResult
import kotlinx.android.synthetic.main.activity_title_white.*
import org.apache.http.Header
import kotlinx.android.synthetic.main.activity_toadd_common.*
import kotlinx.android.synthetic.main.master_info_header_layout.*

/**
 * Created by bcb on 2018/2/10.
 */

class ChatAddCommonActivity : BaseActivity(), CMJsonCallback ,View.OnClickListener{


    private val TO_ADD_COMMON = 30//去添加常用语
    private var index:Int? = -1
    private var content:String? = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_toadd_common)
        ButterKnife.bind(this)
        initView()
    }

    private fun initView() {
        iv_back.setImageResource(R.drawable.icon_close_blue)
        tv_add.setOnClickListener(this)
        iv_back.setOnClickListener(this)
        HintKb.showKb(this)
         index = intent.getIntExtra("index",-1)
         content = intent.getStringExtra("content")
        if (index!=-1)
        {
            tv_title.setText("编辑常用语")
            tv_add.setText("保存")
            if(!TextUtils.isEmpty(content))
            {
                et_common.setText(content)
            }
        }else{
            tv_title.setText("添加常用语")
            tv_add.setText("添加")
        }
    }



    override fun onSuccess(tag: String, obj: Any?, headers: Array<Header>) {
        if (obj == null) {
            return
        }
        val data = obj as ChangeCommonResult?
        val code = data!!.code
        if (code == 0) {
            val result = data.result
            var intent:Intent= Intent()
            intent.putExtra("common_data",result)
            setResult(TO_ADD_COMMON,intent)
            finish()
            overridePendingTransition(R.anim.push_buttom_out, R.anim.still)
            return
        } else {
            ToastUtils.toast(this@ChatAddCommonActivity, data.message)
        }


    }

    override fun onBackPressed() {
        super.onBackPressed()
        overridePendingTransition(R.anim.push_buttom_out, R.anim.still)
    }

    override fun onFail(tag: String, code: Int, message: String, headers: Array<Header>) {
        ToastUtils.toast(this@ChatAddCommonActivity, message)
    }

    override fun onClick(v: View?) {
        when(v!!.id){
            R.id.tv_add->{
                val userBean = MasterApplication.getInstance().userBean
                if (userBean == null)
                {
                    return
                }
                val common = et_common!!.text.toString().trim()
                if (TextUtils.isEmpty(common))
                {
                    ToastUtils.toast(this,"不能为空")
                    return
                }
                if (sender==null)
                {
                    sender = CMHttpSender()
                }
                var params = HashMap<String,String>()
                params.put("uid",userBean.uid)
                params.put("content",common)
                var cmtype = CMRequestType.MASTER_ADD_COMMON
                if (index != -1)
                {
                    cmtype = CMRequestType.MASTER_UPDATA_COMMON
                    params.put("index",index.toString())
                }
                sender.postWithTokenOnUI(this,cmtype,params,AppConstants.SOURCE_SECRET,this)
            }
            R.id.iv_back->{
                finish()
                overridePendingTransition(R.anim.push_buttom_out, R.anim.still)
            }
        }
    }
}
