package com.bcb.master.ui

import android.app.Activity
import android.content.ComponentName
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.view.View
import android.widget.AdapterView
import android.widget.ExpandableListView
import android.widget.Toast
import butterknife.BindView
import butterknife.ButterKnife
import com.bcb.master.R
import com.bcb.master.adapter.ContactSerivceAdapter
import com.bcb.master.clicke.BaseClickToPagerUtils
import com.bcb.master.common.ShowDialog
import com.bcb.master.image.Util
import com.bcb.master.model.ContactSeriviceQuestionBean
import com.bcb.master.model.ContactSeriviceQuestionBean.item
import com.bcb.master.utils.ToastUtils
import kotlinx.android.synthetic.main.activity_contact_service.*
import kotlinx.android.synthetic.main.activity_title_white.*
import java.lang.Exception

class ContactServiceActivity : BaseActivity() ,View.OnClickListener{


    companion object {
        public fun getInstance(activity:Activity){
            val intent = Intent(activity, ContactServiceActivity::class.java)
            activity.startActivity(intent)
        }

    }
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_contact_service)
        initData()
        initView()
    }

    private fun initView() {
        tv_title.setText("联系客服")
        iv_back.setOnClickListener(this)
        rl_wx.setOnClickListener(this)
        rl_tel.setOnClickListener(this)
        val adapter = ContactSerivceAdapter(arrayList, this)

        elv_question.setGroupIndicator(null)
        elv_question.setAdapter(adapter)
    }

    private var arrayList: ArrayList<ContactSeriviceQuestionBean> = ArrayList()

    private fun initData() {
        val bean = ContactSeriviceQuestionBean()
        bean.title = "降级封号"
        bean.imgres = R.drawable.icon_demotion
        var items = ArrayList<item>()
        var item = item()
        item.title = "账户降级了怎么办？"
        item.datares = R.string.demotion
        var item2 = item()
        item2.title = "如何规范填写问诊小结？"
        item2.datares = R.string.fill_in_report
        items.add(item)
        items.add(item2)
        bean.items = items
        arrayList.add(bean)

        val bean2 = ContactSeriviceQuestionBean()
        bean2.title = "等级考试"
        bean2.imgres = R.drawable.icon_exam
        var items2 = ArrayList<item>()
        var item3 = item()
        item3.title = "如何晋升金牌/专家技师？"
        item3.datares = R.string.promote
        var item4 = item()
        item4.title = "我什么不能参与晋级考试/考试什么时候通过？"
        item4.datares = R.string.cant_join_exam
        items2.add(item3)
        items2.add(item4)
        bean2.items = items2
        arrayList.add(bean2)

        val bean3 = ContactSeriviceQuestionBean()
        bean3.title = "结算到账"
        bean3.imgres = R.drawable.icon_money_ques
        var items3 = ArrayList<item>()
        var item5 = item()
        item5.title = "提现什么时候到账？"
        item5.datares = R.string.accound_time
        var item6 = item()
        item6.title = "如何更改支付宝账号/变更手机号码？"
        item6.datares = R.string.change_phone
        items3.add(item5)
        items3.add(item6)
        bean3.items = items3
        arrayList.add(bean3)






    }
    private val url ="mqqwpa://im/chat?chat_type=wpa&uin=4001151781"

    fun ClickImg() {
        if (isWeixinAvilible(this)) {
            val intent = Intent()
            val cmp = ComponentName("com.tencent.mm", "com.tencent.mm.ui.LauncherUI")
            intent.action = Intent.ACTION_MAIN
            intent.addCategory(Intent.CATEGORY_LAUNCHER)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            intent.component = cmp
            startActivity(intent)

        } else {
            ToastUtils.toast(this, "没有安装微信客户端！")
        }
    }
    fun isWeixinAvilible(context: Context): Boolean {
        val packageManager = context.packageManager// 获取packagemanager
        val pinfo = packageManager.getInstalledPackages(0)// 获取所有已安装程序的包信息
        if (pinfo != null) {
            for (i in pinfo.indices) {
                val pn = pinfo[i].packageName
                if (pn == "com.tencent.mm") {
                    return true
                }
            }
        }
        return false
    }

    override fun onClick(v: View?) {
        when(v!!.id)
        {
            R.id.iv_back->{
                finish()
            }
            R.id.rl_tel->{
                ShowDialog.showTel("4006801781",this)
            }
            R.id.rl_wx->{
                try {
//                    startActivity(packageManager.getLaunchIntentForPackage("com.tencent.mobileqq"))
                    ClickImg()
                }catch (error :Exception)
                {
                    ToastUtils.toast(this,"请检查是否安装微信")
                }
            }
        }
    }
}