package com.bcb.master.ui

import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.widget.Toast
import com.bcb.log.BCBLog
import com.bcb.master.AppConstants
import com.bcb.master.MasterApplication
import com.bcb.master.R
import com.bcb.master.common.SharedPreferencesUtils
import com.bcb.master.utils.PrefUtils
import com.loopj.http.bcb.CMHttpSender
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.entity.SettingsData
import kotlinx.android.synthetic.main.activity_notification_setting.*
import kotlinx.android.synthetic.main.activity_title.*
import org.apache.http.Header
import org.jetbrains.anko.toast

/**
 * Created by bcb on 2017/11/20.
 */
class NotificationSettingActivity : BaseActivity(), CMJsonCallback ,View.OnClickListener{

private var enable_notice = 0
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_notification_setting)
        initView()
        initData()
    }

    private fun initView() {
        setTitlePadding(findViewById(R.id.rl_title))
        iv_switch.setOnClickListener(this)
        iv_back.setOnClickListener(this)
        tv_title.setText("推送设置")
    }

    private fun initData() {
        enable_notice = PrefUtils.getInt(this, "enable_notice", 0)
        setButtonShow()
        if (sender == null)
        {
            sender = CMHttpSender()
        }
        val params = HashMap<String, String>()
        params.put("uid", MasterApplication.uid)

        try {
            sender.getWithTokenOnUI(this, CMRequestType.USER_ONE_TO_ONE_GETSETTINGS_NEW, params, AppConstants.SOURCE_SECRET, this)
        } catch (e: Exception) {
            BCBLog.d("", e)
        }

    }
    //上传按钮状态
    private fun requestChangeStatus() {
        if (sender == null)
        {
            sender = CMHttpSender()
        }
        val params = HashMap<String, String>()
        params.put("uid", MasterApplication.uid)
        params.put("enable_notice",enable_notice.toString())
        try {
        sender.postWithTokenOnUI(this,CMRequestType.USER_ONE_TO_ONE_SETSETTINGS_NEW,params,AppConstants.SOURCE_SECRET,this)
        } catch (e: Exception) {
            BCBLog.d("", e)
        }
    }
    override fun onSuccess(tag: String, obj: Any?, headers: Array<out Header>?) {
        when(tag){
            "get_switches_settings"->{
                if (obj!=null)
                {
                    var data :SettingsData = obj as SettingsData
                    if (data.code == 0)
                    {
                        var result = data.result
                        if (result.settings == null)
                        {
                            return
                        }
                        enable_notice = result.settings.enable_notice
                        PrefUtils.putInt(this,"enable_notice",enable_notice)
                        setButtonShow()

                    }

                }else{
                    toast(getString(R.string.network))
                }
            }
            "set_switches_settings"->{
                if (obj == null)
                {
                    toast(getString(R.string.network))
                    //设置失败还原状态
                    setButtonClickOverStatus()
                    return
                }
                var data :SettingsData = obj as SettingsData
                if(data.code ==0)
                {
                    toast("设置成功")
                    PrefUtils.putInt(this,"enable_notice",enable_notice)
                }else{
                    //设置失败还原状态
                    setButtonClickOverStatus()
                    toast("设置失败")
                }
            }
        }
    }
    //设置按钮显示效果根据状态值
    private fun setButtonShow() {
        if (enable_notice == 1) {
            iv_switch.setImageResource(R.drawable.switch_on)
        } else if (enable_notice == 0) {
            iv_switch.setImageResource(R.drawable.switch_off)
        }
    }

    override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
        if (!TextUtils.equals(tag,"set_switches_settings"))
        {
            return
        }
        setButtonClickOverStatus()
        toast(getString(R.string.network))
    }
    override fun onClick(v: View) {
       when(v.id)
       {
           //点击按钮
           R.id.iv_switch ->{
               setButtonClickOverStatus()
               requestChangeStatus()
           }
           R.id.iv_back ->{
               finish()
           }
       }
    }


    private fun setButtonClickOverStatus() {
        if (enable_notice == 0) {
            iv_switch.setImageResource(R.drawable.switch_on)
            enable_notice = 1
        } else {
            iv_switch.setImageResource(R.drawable.switch_off)
            enable_notice = 0
        }
    }


}