package com.bcb.master.ui

import android.app.Activity
import android.graphics.Color
import android.os.Bundle
import android.text.TextUtils
import com.bcb.master.AppConstants
import com.bcb.master.AppSession.isPushVideoCloseDialogShow
import com.bcb.master.MasterApplication
import com.bcb.master.R
import com.bcb.master.model.FeedbackMessage
import com.blankj.utilcode.util.SpanUtils
import com.blankj.utilcode.util.ToastUtils
import com.loopj.http.bcb.CMHttpSender
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.entity.BaseEntity
import com.socks.library.KLog
import com.tencent.rtc.VideoCloseMessage
import kotlinx.android.synthetic.main.dialog_qxq_video_close.*
import org.apache.http.Header
import org.greenrobot.eventbus.EventBus
import java.util.*

class PushQXQCloseFeedbackActivity : Activity() {
    var  question_id:String=""
    var  question_content:String=""
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.dialog_qxq_video_close)
        isPushVideoCloseDialogShow = true
        initData()
        initView()
    }

    private fun initView() {
        overridePendingTransition(0,0)

        SpanUtils.with(tv_dialog_content)
                .append("您是否能帮客户解决")
                .append("“"+question_content+"”")
                .append("此问题如果暂时没有思路可以点击")
                .append("没有思路").setUnderline().setQuoteColor(Color.parseColor("#FF713B")).setForegroundColor(Color.parseColor("#FF713B"))
                .append("。这样会送给用户一次免费体验次数")
                .create()
        tv_no_ideas.setOnClickListener{
            toFeedback(false)
        }
        tv_can_resolve.setOnClickListener{
            toFeedback(true)
        }
    }

//    override fun onNewIntent(intent: Intent?) {
//        super.onNewIntent(intent)
//        initData()
//        initView()
//    }

    open fun toFeedback( isOk: Boolean) {
        val userBean = MasterApplication.getInstance().userBean ?: return
        val sender = CMHttpSender()
        val params = HashMap<String, String>()
        params["uid"] = userBean.uid
        params["question_id"] = question_id
        params["is_solved"] = if (isOk) "Y" else "N"
        try {
            sender.postWithTokenOnUI(applicationContext, CMRequestType.QXQ_REQUEST_QXQ_QUESTION_CLOSE_STATE, params, AppConstants.SOURCE_SECRET,
                    object : CMJsonCallback {
                        override fun onSuccess(tag: String, obj: Any, headers: Array<Header>) {
                            if(obj!=null)
                            {
                                var bean  = obj as BaseEntity
                                if(bean.code == 0)
                                {
                                    ToastUtils.showLong("反馈成功！")
                                    //刷新聊天详情接口
                                    EventBus.getDefault().post(FeedbackMessage())
                                    finish()
                                }else{
                                    ToastUtils.showLong(tag)
                                }
                            }

                        }

                        override fun onFail(tag: String, code: Int, message: String, headers: Array<Header>) {}
                    })
        } catch (e: Exception) {
            KLog.e(e)
        }
    }

    private fun initData() {
        if (intent == null)
        {
            finish()
            return
        }
         question_id = intent.getStringExtra("question_id")
        var question = intent.getStringExtra("question_content")
        if (TextUtils.isEmpty(question))
        {
            question = ""
        }
        if (question.length>10)
        {
            question_content = question.substring(0,10) +"..."
        }
    }

    override fun onDestroy() {
        isPushVideoCloseDialogShow = false
        super.onDestroy()
    }
    override fun finish() {
        super.finish()
        overridePendingTransition(0,0)
    }
}