package com.bcb.master.ui

import android.annotation.SuppressLint
import android.app.Activity
import android.app.AlertDialog
import android.content.Intent
import android.graphics.PorterDuff
import android.graphics.drawable.LayerDrawable
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Message
import android.support.v4.app.FragmentTransaction
import android.support.v7.widget.AppCompatRatingBar
import android.text.Layout
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RadioGroup
import android.widget.TextView
import cn.jpush.android.api.JPushInterface
import com.bcb.log.BCBLog
import com.bcb.master.*
import com.bcb.master.common.ShowDialog
import com.bcb.master.fragment.RobQuestionFragment
import com.bcb.master.fragment.UserInfoFragment
import com.bcb.master.model.QuestionAnswer
import com.bcb.master.model.QuestionBean
import com.bcb.master.model.RefreshEvent
import com.bcb.master.model.UserBean
import com.bcb.master.utils.TimeUtil
import com.bcb.master.utils.ToastUtils
import com.bcb.master.utils.Util
import com.bcb.master.utils.can_answer_normal
import com.bcb.master.widget.NestRadioGroup
import com.google.gson.Gson
import com.google.gson.JsonArray
import com.iflytek.cloud.resource.Resource
import com.loopj.http.bcb.CMHttpSender
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.data.Master
import com.loopj.http.entity.*
import com.nostra13.universalimageloader.core.ImageLoader
import com.umeng.analytics.MobclickAgent
import com.zhy.view.flowlayout.FlowLayout
import com.zhy.view.flowlayout.TagAdapter
import kotlinx.android.synthetic.main.activity_nodata.*
import kotlinx.android.synthetic.main.activity_push_question_detail.*
import org.apache.http.Header
import org.greenrobot.eventbus.EventBus
import org.jetbrains.anko.style
import java.io.Serializable
import java.lang.reflect.Method

/**
 * Created by bcb on 2018/3/2.
 */

class PushQuestionDialogActivity : BaseActivity(),View.OnClickListener ,CMJsonCallback{
    private var isclose = false
    private val REQUEST_SUCCESS = 10//请求成功
    private var comment_list : ArrayList<CommentData>? = null
    private var carUserInfo :com.loopj.http.entity.UserBean? = null
    private var handler:Handler = @SuppressLint("HandlerLeak")
    object : Handler(){
        override fun handleMessage(msg: Message?) {
            super.handleMessage(msg)
            if (msg==null)
            {
                return
            }
            try {
                if(msg.what == REQUEST_SUCCESS)
                {
                    val bundle = msg.data
                    val tag = bundle.getString("tag")
                    val obj = bundle.getSerializable("data")
                    when(tag)
                    {
                        "question_getmatchedquestioninfo"->{
                            //获取推送问题的详情
                            data = obj as  PushQuestionData
                            if(data!!.code !=0)
                            {
                                ToastUtils.toast(context,data!!.message)
                                finish()
                                overridePendingTransition(0, 0)
                                return
                            }
                            showView()
                        }
                        "question_giveupmatchedquestion"->{
                            //反馈关闭推送原因
                            var result = obj as BaseEntity
                            if(result.code != 0)
                            {
                                ToastUtils.toast(context,data!!.message)
                            }
                            if(isclose)
                            {
                                ToastUtils.toast(context,"反馈成功！")
                                finish()
                                overridePendingTransition(0, 0)
                            }
                        }
                        "mechanic_getuserprofile"->{
                            val bean = obj as CarUserInfoBean
                            if (bean.code !=0)
                            {
                                ToastUtils.toast(context,data!!.message)
                                return
                            }
                            val result =  bean.result
                            carUserInfo = result.user
                            initCarUserInfo()
                            //获取用户信息
                            getCarUserCommentList()
                        }
                        "mechanic_getusercommentlist"->{
                            //获取技师评价用户列表
                            val bean = obj as MasterCommentUserListBean
                            if (bean.code !=0)
                            {
                                ToastUtils.toast(context,data!!.message)
                                return
                            }
                            val result =  bean.result
                            comment_list = result.comment_list
                            ShowCommentList()
                        }
                    }

                }
            } catch (e: Exception) {
            }
        }
    }

    override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
        if(obj == null)
        {
            return
        }
        var msg = Message()
        msg.what = REQUEST_SUCCESS
        val bundle = Bundle()
        bundle.putString("tag",tag)
        bundle.putSerializable("data", obj as Serializable?)
        msg.data = bundle
        handler.sendMessage(msg)

    }

    private fun ShowCommentList() {
        ll_comment_list.removeAllViews()
        if (comment_list!=null && comment_list!!.size>0)
        {
            ll_none.visibility = View.GONE
            ll_comment_list.visibility = View.VISIBLE
            sv_comment_list.visibility = View.VISIBLE
            v_bottom_line.visibility = View.VISIBLE
            for (comment: CommentData in comment_list!!){
                var item = LayoutInflater.from(this).inflate(R.layout.activity_comment_user_item,null)
                var iv_user =item.findViewById(R.id.iv_user) as ImageView
                var tv_name =item.findViewById(R.id.tv_name) as TextView
                var tv_time =item.findViewById(R.id.tv_time) as TextView
                var ratingBar = item.findViewById(R.id.ratingBar) as AppCompatRatingBar
                var tv_comment_content =item.findViewById(R.id.tv_comment_content) as TextView
                var from_user = comment.from_user
                ratingBar.rating = comment.star.toFloat()
                val progressDrawable = ratingBar.progressDrawable as LayerDrawable
                progressDrawable.getDrawable(2).setColorFilter(resources.getColor(R.color.red4422),PorterDuff.Mode.SRC_ATOP)
                ImageLoader.getInstance().displayImage(from_user.avatar_file,iv_user,options)
                tv_name.text = from_user.user_name
                tv_time.text = comment.created_at_friendly
                var content = comment.content
                if (TextUtils.isEmpty(content))
                {
                    content = "此评价没有内容！"
                }
                tv_comment_content.text = content
                ll_comment_list.addView(item)
            }
        }else{
            ll_none.visibility = View.VISIBLE
            ll_comment_list.visibility = View.GONE
            sv_comment_list.visibility = View.GONE
            v_bottom_line.visibility = View.INVISIBLE
        }
    }


    override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
        when(tag)
        {
            "mechanic_getuserprofile"->{
                ToastUtils.toast(context,message)
                return
            }
            "mechanic_getusercommentlist"->{
                ToastUtils.toast(context,message)
                return
            }
        }
        ToastUtils.toast(context,message)
        finish()
        overridePendingTransition(0, 0)
    }

    override fun onClick(v: View?) {
        when(v!!.id)
        {
            R.id.iv_close->{
//                finish()
//                overridePendingTransition(0, 0)
                rl_common.visibility = View.VISIBLE
                rl_detail.visibility = View.GONE
                rl_dialog.visibility = View.GONE
                iv_close.visibility = View.GONE
                rl_user_all_info.visibility = View.GONE
                toUploadReasons("")

            }
            R.id.ll_to_detail->{
                rl_detail.visibility = View.VISIBLE
                rl_dialog.visibility = View.GONE
            }
            R.id.iv_back->{
                rl_detail.visibility = View.GONE
                rl_dialog.visibility = View.VISIBLE
            }
            R.id.iv_rob_question->{
                //抢单
                try {
                    val questionBean = Gson().fromJson<QuestionBean>(Gson().toJson(data!!.result.question), QuestionBean::class.java)
                    toRobQuestion(this,questionBean)
                } catch (e: Exception) {
                    BCBLog.d("",e)
                }
            }
            R.id.tv_result_ok->{
                finish()
                overridePendingTransition(0, 0)
            }
            R.id.rl_user_info->{
                if (carUserInfo !=null && comment_list!=null)
                {
                    initCarUserInfo()
                    ShowCommentList()
                    return
                }

                getCarUserInfo()
            }
            R.id.iv_info_back->{
                rl_user_all_info.visibility = View.GONE
                iv_close.setImageResource(R.drawable.icon_dialog_close)
                rl_detail.visibility = View.VISIBLE
            }
        }
    }
    //获取车主用户的信息
    private fun getCarUserInfo() {
        if (sender == null)
        {
            sender = CMHttpSender(context)
        }
        if (data == null)
        {
            return
        }
        var user = data!!.result.user
        if(user == null)
        {
            return
        }
        val userid = user.uid
        var params = HashMap<String,String>()
        params.put("user_id",userid)
        try {
            sender.getWithTokenOnUI(context,CMRequestType.GET_CARUSER_INFO,params,AppConstants.SOURCE_SECRET,this)
        } catch (e: Exception) {
            BCBLog.d("",e)
        }
    }
    private fun getCarUserCommentList() {
        //获取技师评价用户列表
        var params = HashMap<String,String>()
        params.put("user_id",data!!.result.user.uid)
        params.put("limit","5")
        try {
            sender.getWithTokenOnUI(context,CMRequestType.GET_MASTER_COMMENT_USER_LIST,params,AppConstants.SOURCE_SECRET,this)
        } catch (e: Exception) {
            BCBLog.d("",e)
        }
    }
    private var status: Int = 1//1是从前台启动， 0是从后台启动的
    private val context  = this
    private var qid: String = ""
    private var beginTransaction: FragmentTransaction? =null
    private var data:PushQuestionData? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_push_question_detail)
        initData()
        initView()
    }



    private fun initView() {
        iv_back.setOnClickListener(this)
        iv_close.setOnClickListener(this)
        ll_to_detail.setOnClickListener(this)
        iv_rob_question.setOnClickListener(this)
        tv_result_ok.setOnClickListener(this)
        rl_user_info.setOnClickListener(this)
        iv_info_back.setOnClickListener(this)
    }

    private fun initData() {
        JPushInterface.clearAllNotifications(context)
        var intent = intent
        status = intent.getIntExtra("status",1)
        AppSession.isPushQuestionDialogShow = true
        val userBean = MasterApplication.getInstance().userBean
        if (userBean == null)
        {
            finish()
            return
        }
        val params = HashMap<String,String>()
        if (intent !=null)
        {
            if(intent.hasExtra("qid"))
            {
                qid = intent.getStringExtra("qid")
            }
            params.put("question_id",qid)
        }
        beginTransaction = supportFragmentManager.beginTransaction()
        params.put("uid",userBean.uid)
        try {
            sender.getWithTokenOnUI(context,CMRequestType.GET_PUSH_QUESTION_DATA,params,AppConstants.SOURCE_SECRET,this)
        } catch (e: Exception) {
            BCBLog.d("",e)
        }
    }
    //展示问题dialog
    private fun showView() {
        pb_loading.visibility = View.GONE
        rl_dialog.visibility = View.VISIBLE
        iv_close.visibility = View.VISIBLE
        if (data == null) {
            return
        }
//        var robFragment = RobQuestionFragment()
//        var bundle = Bundle()
//        bundle.putSerializable("data",data)
//        robFragment.arguments = bundle
//        beginTransaction!!.add(R.id.fl_user_info,robFragment,"rob_page").commit()

        val question = data!!.result.question
        //显示问题
        if (question == null) {
            return
        }
        if (TextUtils.isEmpty(question.series)) {
            tv_car_name.text = "车型:未知"
        } else {
            tv_car_name.text = "车型:" + question.series
        }
        tv_money.text = "¥ " + question.consult_price_amount
        val attachs_big = question.attachs_big
        if (attachs_big != null && attachs_big.size > 0) {
            tv_question_content.text = "[图]" + question.question_content
        } else {
            tv_question_content.text = question.question_content

        }
        val user = data!!.result.user
        if (user == null) {
            return
        }
        ImageLoader.getInstance().displayImage(user.avatar_file, civ_avater, options)
        tv_username.text = user.user_name
        val list = data!!.result.user_tags
        tf_flowlayout.setAdapter(object : TagAdapter<String>(list) {
            override fun getView(parent: FlowLayout, position: Int, s: String): View {
                val tv = LayoutInflater.from(context).inflate(R.layout.item_tag, null, false) as TextView
                tv.setText(s)
                return tv
            }
        })
        //显示问题详情
        if (attachs_big != null && attachs_big.size > 0) {
            tv_content.text = "[图]" + question.question_content
        } else {
            tv_content.text = question.question_content
        }
        ImageLoader.getInstance().displayImage(user.avatar_file,civ_avater_detail,options)
        tv_user_name.setText(user.user_name)
//        if (list!=null && list.size>=2)
//        {
//            tv_tag1.setText(list.get(0))
//            tv_tag2.setText(list.get(1))
//        }
        tv_tag1.setText("平均对话次数："+user.avg_append)
        tv_tag2.setText("好评率："+user.favorable_rate_str)
        var model_year = user.model_year
        var model_name = user.model_name
        val brand_name = user.brand_name
        val series_name = user.series_name
        if(!TextUtils.isEmpty(model_year))
        {
            model_year = model_year+"款"
        }else{
            model_year = ""
        }
        if(!TextUtils.isEmpty(model_name))
        {
            model_name = model_name+"型"
        }else{
            model_name = ""
        }
        if (!TextUtils.isEmpty(brand_name))
        {
            val my_car = model_year + brand_name + series_name + model_name
            tv_car_detail.setText(my_car)
            tv_car_detail.visibility = View.VISIBLE
        }

        val kilometers = question.question_extra.kilometers
        if (!TextUtils.isEmpty(kilometers))
        {
            tv_car_kilometers.setText(kilometers+"公里")
            tv_car_kilometers.visibility = View.VISIBLE
        }
        var related_question_count = question.related_question_count
        tv_other_title.setText("我已服务TA "+related_question_count+"次")
        val attachs_small = question.getAttachs_small()
        if (attachs_small.size > 0) {
            ll_logo.visibility = View.VISIBLE
            //            imageLoader.displayImage(questionBean.getAttachs_small().get(0),
            //                    iv_logo, options);
            ll_logo.removeAllViews()
            var i = 0
            for (imgUrl in attachs_small) {
                val iv_loge = View.inflate(ll_logo.context, R.layout.item_imageview, null) as ImageView
                val params = LinearLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT)
                params.width = ll_logo.resources.getDimension(R.dimen.px124).toInt()
                params.height = ll_logo.resources.getDimension(R.dimen.px124).toInt()
                params.setMargins(0, 0, 26, 0)
                iv_loge.scaleType = ImageView.ScaleType.FIT_START
                iv_loge.minimumHeight = R.dimen.px124
                iv_loge.minimumWidth = R.dimen.px124
                iv_loge.contentDescription = null
                iv_loge.layoutParams = params
                imageLoader.displayImage(imgUrl, iv_loge, options)
                val finalI = i
                iv_loge.setOnClickListener {
                    val intent = Intent(context,
                            ImageDetialActivity::class.java)
                    intent.putExtra("url", question.getAttachs_big().get(finalI))
                    context.startActivity(intent)
                    overridePendingTransition(0, 0)
                }
                i++
                ll_logo.addView(iv_loge)
            }

        } else {
            ll_logo.visibility = View.GONE
        }
        val user_last_questions = data!!.result.user_last_questions
        /*if (user_last_questions.size > 0) {
            rl_other_question.visibility = View.VISIBLE
            ll_other_question.removeAllViews()
            for (qb in user_last_questions) {
                val view = LayoutInflater.from(this).inflate(R.layout.item_push_dialog_last_question, null)
                val tv_time2 = view.findViewById(R.id.tv_time2) as TextView
                val tv_content2 = view.findViewById(R.id.tv_content2) as TextView
                tv_time2.text = TimeUtil.ToTime(qb.add_time)
                var params = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT,LinearLayout.LayoutParams.WRAP_CONTENT)
                params.topMargin = Util.dip2px(context, resources.getDimensionPixelOffset(R.dimen.px6).toFloat())
                view.layoutParams = params
                tv_content2.text = if (qb.attachs.size > 0) "[图]" + qb.question_content else qb.question_content
                ll_other_question.addView(view)
            }
        } else {
            rl_other_question.visibility = View.GONE
        }*/
        if (TextUtils.isEmpty(question.series)) {
            tv_car_name1.text = "车型:未知"
        } else {
            tv_car_name1.text = "车型:" + question.series
        }
        tv_money1.text = "¥ " + question.consult_price_amount
        //显示问题关闭反馈
        val give_up_reasons = data!!.result.give_up_reasons
        if (give_up_reasons != null && give_up_reasons.size >= 3) {
            rb_cause1.text = give_up_reasons[0]
            rb_cause2.text = give_up_reasons[1]
            rb_cause3.text = give_up_reasons[2]
            rg_selector.setOnCheckedChangeListener(object:RadioGroup.OnCheckedChangeListener{
                override fun onCheckedChanged(group: RadioGroup?, checkedId: Int) {
                    isclose = true
                    if (checkedId == R.id.rb_cause1)
                    {
                        toUploadReasons(give_up_reasons[0])
                    }else if(checkedId == R.id.rb_cause2)
                    {
                        toUploadReasons(give_up_reasons[1])
                    }else if(checkedId == R.id.rb_cause3)
                    {
                        toUploadReasons(give_up_reasons[2])
                    }
                }

            })
//            rg_selector.setOnCheckedChangeListener(RadioGroup.OnCheckedChangeListener { group, checkedId ->
//
//                when(checkedId)
//                {
//                    R.id.rb_cause1->{
//
//                    }
//                    R.id.rb_cause2->{
//                        toUploadReasons(give_up_reasons[1])
//                    }
//                    R.id.rb_cause3->{
//                        toUploadReasons(give_up_reasons[2])
//                    }
//                }
//            })
        }
        //更换没有内容的图标
        iv_none.setImageResource(R.drawable.icon_comment_nodata)
        ll_none.setBackgroundColor(resources.getColor(R.color.f5))
        tv_none.setText("该用户还没有收到过评价")

    }

    //显示用户详情用户信息
    private fun initCarUserInfo() {
        if (carUserInfo == null)
        {
            return
        }
        ImageLoader.getInstance().displayImage(carUserInfo!!.avatar_file,civ_avater_detail3,options)
        tv_user_name3.text = carUserInfo!!.user_name
        val keywords = carUserInfo!!.car_series_recently
        val credit_score = carUserInfo!!.credit_score
        tv_tag3.text = "常用车型："+keywords
        tv_tag4.text = "信誉分："+credit_score
        iv_close.setImageResource(R.drawable.icon_circle_close)
        rl_user_all_info.visibility = View.VISIBLE
        rl_detail.visibility = View.GONE
        var commented_tags = carUserInfo!!.commented_tags

        if (commented_tags == null || commented_tags.size<=0)
        {
            ll_tags_layout.visibility = View.GONE
            return
        }
        ll_tags_layout.removeAllViews()
        for (tag:CommentTag in commented_tags)
        {
            var item = LayoutInflater.from(this).inflate(R.layout.item_comment_tag,null)
            var tv_tag = item.findViewById(R.id.tv_tag) as TextView
            var tv_count = item.findViewById(R.id.tv_count) as TextView
            tv_tag.text = tag.tag
            tv_count.text = tag.count.toString()
            ll_tags_layout.addView(item)
        }
    }

    fun toUploadReasons(s: String) {
        val params = HashMap<String,String>()
        params.put("question_id",qid)
        params.put("reason",s)
        try {
            sender.postWithTokenOnUI(this,CMRequestType.POST_PUSH_QUESTION_REASON,params,AppConstants.SOURCE_SECRET,this)
        } catch (e: Exception) {
            BCBLog.d("",e)
        }
    }

    private fun toRobQuestion(ctx: Activity, questionBean: QuestionBean) {
        if (sender == null) {
            sender = CMHttpSender(ctx)
        }

        val sign = java.util.HashMap<String, String>()
        val userBean = MasterApplication.getInstance().userBean
        if (userBean == null) {
            ToastUtils.toast(ctx, "登录失效，请重新登录后尝试！")
            return
        }
        if (can_answer_normal(this,true) == 0)
        {
            //不能回答问题，没有权限，弹广告窗
            return
        }
        if ("0" != questionBean.mechanic_uid) {
            if (TextUtils.equals(userBean.uid, questionBean.getMechanic_uid()))
            //问题已经是你的了
            {
                toChat(ctx, questionBean)
                finish()
                overridePendingTransition(0,0)
            } else {
                val str = "对不起，别的技师已经捷足先登了"
                rl_rob_result.visibility = View.VISIBLE
                rl_dialog.visibility = View.GONE
                iv_close.visibility = View.GONE
                tv_result_content.text = str
                tv_result_title.text = "很抱歉，手慢无"

            }
            return
        }
        val config = MasterApplication.getConfig(ctx)
        if (config != null) {
            var grab_alert = config.grab_alert
            //判断金额37.5提示新文案
            if ("37.5".equals(questionBean.consult_price_amount))
            {
                grab_alert = "该服务已开启退款保障，如无优质解答，可能会被退款。"
            }
            if (!TextUtils.isEmpty(grab_alert)) {
                val str = arrayOf("",grab_alert, "取消", "继续抢答")
                ShowDialog.showCompleteDialogWithOptions(str, ctx, object : ShowDialog.OnDialogClick() {
                    override fun onClick(dialogView: AlertDialog, view: View, index: Int) {
                        if (index == 2) {
                            toRobQuestionRequest(ctx, questionBean, sign, userBean)
                        }
                        dialogView.dismiss()
                    }
                })
                return
            }
            toRobQuestionRequest(ctx, questionBean, sign, userBean)
        } else {
            ToastUtils.toast(ctx, "登录异常请，尝试重新登录！")
        }

    }
    private fun toChat(ctx: Activity, questionBean: QuestionBean) {
        AppSession.questionAnswer = QuestionAnswer()
        AppSession.questionAnswer.questionBean = questionBean
        AppSession.questionAnswer.uid = MasterApplication.getUserBean(ctx).uid
        if (status == 0)
        {
            val i = Intent(context, AppStartActivity::class.java)
            i.putExtra("type",1001)
            startActivity(i)
            return
        }
        MobclickAgent.onEvent(ctx, "DJTWXQ")
        //					questionBean.setIs_expert(false);
        val intent = Intent(ctx, ChatActivity::class.java)
        intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK or Intent.FLAG_ACTIVITY_CLEAR_TOP
        intent.putExtra("is_expert", false)
        startActivity(intent)
    }
    private fun toRobQuestionRequest(ctx: Activity, questionBean: QuestionBean, sign: java.util.HashMap<String, String>, userBean: UserBean) {
//        if (loading == null) {
//            loading = ShowDialog.showLoadingDialog("抢单中", ctx)
//        }
        pb_loading.visibility = View.VISIBLE
        sign.put("uid", userBean.uid)
        sign.put("qid", questionBean.question_id)
        try {
            sender.getWithTokenOnUI(ctx, CMRequestType.ROB_QUESTION_STATUS, sign, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
                override fun onSuccess(tag: String, obj: Any?, headers: Array<Header>) {
                    pb_loading.visibility = View.GONE

//                    if (loading != null && loading!!.isShowing()) {
//                        loading!!.dismiss()
//                    }
                    if (obj == null) {
                        return
                    }
                    val data = obj as BaseEntity?
                    val code = data!!.code
                    if (code == 0) {
//                        ShowDialog.showTimerDialog(arrayOf("抢单成功", "3秒后进入聊天页面！"), ctx, object : ShowDialog.OnDialogClick() {
//                            override fun onClick(dialogView: AlertDialog, view: View?, index: Int) {
//                                toChat(ctx, questionBean)
//                            }
//                        }, 3000)
                        toChat(ctx, questionBean)
                        finish()
                        overridePendingTransition(0,0)
                        return
                    } else if (code == 10051) {
                        rl_rob_result.visibility = View.VISIBLE
                        rl_dialog.visibility = View.GONE
                        iv_close.visibility = View.GONE
                        var str = "对不起，别的技师已经捷足先登了"
                        if (!TextUtils.isEmpty(data.message)) {
                            str = data.message
                        }
                        tv_result_title.text = "很抱歉，手慢无"
                        tv_result_content.text = str

                    } else if (code == 10052) {
                        rl_rob_result.visibility = View.VISIBLE
                        rl_dialog.visibility = View.GONE
                        iv_close.visibility = View.GONE
                        var str = "限定时间内只允许抢一单！"
                        if (!TextUtils.isEmpty(data.message)) {
                            str = data.message
                        }
                        tv_result_title.text = "失败了"
                        tv_result_content.text = str

                    } else if (code == 10053) {
                        toChat(ctx, questionBean)
                        finish()
                        overridePendingTransition(0,0)
                    } else if (code == 20053) {
                        rl_rob_result.visibility = View.VISIBLE
                        rl_dialog.visibility = View.GONE
                        iv_close.visibility = View.GONE
                        var str = "问题已转交，不能再抢！"
                        if (!TextUtils.isEmpty(data.message)) {
                            str = data.message
                        }
                        tv_result_title.text = "失败了"
                        tv_result_content.text = str
                    }else{
                        rl_rob_result.visibility = View.VISIBLE
                        rl_dialog.visibility = View.GONE
                        iv_close.visibility = View.GONE
                        var str = "某些因素导致抢单失败，可以联系客服进行咨询"
                        if (!TextUtils.isEmpty(data.message)) {
                            str = data.message
                        }
                        tv_result_title.text = "失败了"
                        tv_result_content.text = str
                    }

                }

                override fun onFail(tag: String, code: Int, message: String, headers: Array<Header>) {
                    pb_loading.visibility = View.GONE

                }
            })
        } catch (e: Exception) {
            BCBLog.d("", e)
        }

    }

    override fun onBackPressed() {
//        super.onBackPressed()
//        overridePendingTransition(0, 0)
    }

    override fun onDestroy() {
        super.onDestroy()
        AppSession.isPushQuestionDialogShow = false
        var event = RefreshEvent()
        event.page = 1
        EventBus.getDefault().post(event)
    }
}

