package com.bcb.master.ui

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import com.bcb.master.AppConstants
import com.bcb.master.AppSession
import com.bcb.master.AppSession.isOpenVideo
import com.bcb.master.AppSession.isQXQChatShow
import com.bcb.master.MasterApplication
import com.bcb.master.R
import com.bcb.master.adapter.QXQChatAdapter
import com.bcb.master.common.ShowDialog
import com.bcb.master.common.ShowDialog.OnDialogClick
import com.bcb.master.image.BitmapTools
import com.bcb.master.manager.PushManager
import com.bcb.master.model.FeedbackMessage
import com.bcb.master.model.PushBean
import com.bcb.master.model.UserBean
import com.blankj.utilcode.util.KeyboardUtils
import com.blankj.utilcode.util.ToastUtils
import com.bumptech.glide.Glide
import com.chad.library.adapter.base.BaseQuickAdapter
import com.google.gson.Gson
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.entity.*
import com.socks.library.KLog
import com.tencent.rtc.Constant
import com.tencent.rtc.RTCActivity
import com.tencent.rtc.VideoCloseMessage
import com.yanzhenjie.permission.AndPermission
import com.yanzhenjie.permission.runtime.Permission
import io.reactivex.Observable
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.activity_chat_qxq.*
import kotlinx.android.synthetic.main.activity_progress.*
import org.apache.http.Header
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import java.util.concurrent.TimeUnit

class QXQChatActivity : BaseActivity(), View.OnClickListener, PushManager.OnJPushMsgListener {
    lateinit var chatAapter: QXQChatAdapter
    lateinit var resultList: ArrayList<QXQChatBean.Message>
    lateinit var userBean: UserBean

    private  var question_id: String = ""
    private  var questionContent: String = ""
    private  var videoId: String = ""
    private var is_closed = "Y"
    private var isSolved  = ""
    private  var create_time: String = ""
    private  var answerAvatar: String = ""
    private  var askAvatar: String = ""
    var isFrist = true
    //是否已经打开视频咨询


    //聊天发送内容
    var content: String = ""
    //
    /**
     * 相册
     */
    private val CODE_GALLERY = 12
    var currPicPath:String = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_chat_qxq)
        initView()
        initData()
    }

    private fun getQuestionDetail() {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        sender.getWithTokenOnUI(this,CMRequestType.QXQ_QA_DETAIL,params,AppConstants.SOURCE_SECRET,object :CMJsonCallback{
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj!=null)
                {
                    var bean = obj as QXQQuestionDetailBean
                    if (bean.code == 0 )
                    {
                        var result = bean.result
                        if ( result!=null)
                        {
                            questionContent = result.content!!
                            is_closed = result.closed_status
                            create_time = result.create_time!!
                            answerAvatar = result.answer_user_avatar!!
                            askAvatar = result.ask_user_avatar!!
                            isSolved = result.is_solved!!

                            var dis = Observable.just("")
                                    .observeOn(AndroidSchedulers.mainThread())
                                    .subscribe {
                                        if (result.price == "0")
                                        {
                                            iv_add_zhuan.visibility = View.VISIBLE
                                        }else{
                                            iv_add_zhuan.visibility = View.GONE
                                        }
                                        if (isSolved == "T")
                                        {
                                            Glide.with(this@QXQChatActivity)
                                                    .load(R.drawable.icon_qxq_zhuan)
                                                    .into(iv_add_zhuan)

                                        }else{
                                            Glide.with(this@QXQChatActivity)
                                                    .load(R.drawable.icon_qxq_zhuan_gray)
                                                    .into(iv_add_zhuan)
                                        }
                                        if ("Y".equals(is_closed))
                                        {
                                            rl_bottom.visibility = View.GONE
                                        }else{
                                            rl_bottom.visibility = View.VISIBLE
                                        }
                                        //设置聊天头像
                                        chatAapter.setAvatar(askAvatar,answerAvatar)
                                        //获取chat列表
                                        getAnswerDetail()
                                    }
                        }
                    }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    private fun initView() {
        EventBus.getDefault().register(this)
        isQXQChatShow = false
        bt_send.setOnClickListener(this)
        iv_back.setOnClickListener(this)
        iv_add_zhuan.setOnClickListener(this)
        iv_add_image.setOnClickListener(this)
        KeyboardUtils.clickBlankArea2HideSoftInput()
        rv_content.layoutManager = LinearLayoutManager(this)
        chatAapter = QXQChatAdapter()
        rv_content.adapter = chatAapter
        et_chat.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {
                rv_content.scrollToPosition(resultList.size - 1)

            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

        })
        et_chat.setOnFocusChangeListener(object : View.OnFocusChangeListener {
            override fun onFocusChange(v: View?, hasFocus: Boolean) {
                if (hasFocus) {
                    bt_send.visibility = View.VISIBLE
                    iv_add_image.visibility = View.GONE
                    iv_add_zhuan.visibility = View.GONE
                } else {
                    bt_send.visibility = View.GONE
                    iv_add_image.visibility = View.VISIBLE
                    iv_add_zhuan.visibility = View.VISIBLE
                }
            }

        })
        chatAapter.setOnItemChildClickListener(object : BaseQuickAdapter.OnItemChildClickListener {
            override fun onItemChildClick(adapter: BaseQuickAdapter<*, *>?, view: View?, position: Int) {
                when (view!!.id) {
                    //重发
                    R.id.tv_chat -> {
                        var lastMessage = resultList.get(resultList.size - 1)
                        lastMessage.sendStatus = 0
                        chatAapter.notifyDataSetChanged()
                        KLog.e(null, "-----$position----------" + view.id)
                        sendMessageToServer(content, lastMessage,"text")
                    }
                }
            }


        })
        et_chat.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {

            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {

            }

        })
    }

    private fun initData() {
        //初始化从通知栏进来的不弹窗标识
        AppSession.isFromPushClick  = false;
        //推送回调
        PushManager.getInstance().addMsgListener(this)
        userBean = MasterApplication.getInstance().userBean

        //
        if(intent!=null)
        {
            question_id = intent.getStringExtra("question_id")
            getQuestionDetail()
            if (intent.hasExtra("question_content"))
            {
                questionContent = intent.getStringExtra("question_content")
            }
            if (intent.hasExtra("request_video_call_id"))
            {
                videoId =  intent.getStringExtra("request_video_call_id")
                //接受
                requestVideoSign(intent.getStringExtra("request_video_call_id"))
            }else{
                //获取视频新资讯消息
                getVideoMsg()
            }
        }else{
            ToastUtils.showLong("数据异常！")
            return
        }


    }

    override fun onStop() {
        super.onStop()
        isFrist = false
    }
    @SuppressLint("CheckResult")
    private fun getVideoMsg() {
        Observable.just("")
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe {
                    if (!isOpenVideo) {
                        requestHasVideo()
                    }

                }
    }

    /**
     * 请求是否有视频请求
     */
    private fun requestHasVideo() {
        KLog.e(null, "----------请求是否有视频请求")
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        sender.getWithTokenOnUI(this, CMRequestType.QXQ_PULL_CALL, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj != null) {
                    var result = obj as QXQVideoCallBean
                    var data = result.result
                    if (result.code == 0 && data != null) {
                        var question_id  = data.question_id
                        var video_call_id = data.video_call_id

                        if (question_id != this@QXQChatActivity.question_id)
                        {
                            //不是当前页面的视频请求
                            toOtherChatPage(video_call_id!!,question_id!!)
                            return
                        }
                        if (!TextUtils.isEmpty(video_call_id))
                        {
                            videoId = video_call_id!!
                            if (videoId!!.toInt() > 0) {
                                //有视频咨询
                                canVideo()
                            } else {
                                if (ad!=null)
                                {
                                    if(ad!!.isShowing)
                                    {
                                      ad!!.dismiss()
                                    }

                                }
                                KLog.e(null, "没有视频咨询")
                            }
                        }
                    }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }
    var ad:AlertDialog?=null
    @SuppressLint("CheckResult")
    private fun canVideo() {
        if (ad !== null && ad!!.isShowing)
        {
            ad!!.dismiss()
        }
        Observable.just("")
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe {
                        ad =   ShowDialog.showConfirmDialog(this@QXQChatActivity, arrayOf(getString(R.string.string_push_video_dialog)), object : OnDialogClick() {
                            override fun onClick(dialogView: AlertDialog?, view: View?, index: Int) {
                                when (index) {
                                    0 -> {
                                        //拒绝
                                        refuseVideo(videoId,question_id)
                                        isOpenVideo = false
                                    }
                                    1 -> {
                                        //接受
                                        requestVideoSign(videoId)
                                    }
                                }
                            }

                        })
                }

    }

    private fun refuseVideo(videoId: String,question_id:String) {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        params.put("video_call_id", videoId)
        params.put("content_type", "call")
        sender.postWithTokenOnUI(this, CMRequestType.QXQ_VIDEO_CONNECT_REFUSED, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj != null) {
                    var data = obj as BaseEntity
                    if (data.code == 0) {
                        KLog.e(null,"成功！")
                    }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    //挂断
    private fun closeVideo(videoId: String) {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        params.put("video_call_id", videoId)
        params.put("content_type", "call")
        sender.postWithTokenOnUI(this, CMRequestType.QXQ_VIDEO_CONNECT_CLOSED, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj != null) {
                    var data = obj as BaseEntity
                    if (data.code == 0) {
                        KLog.e(null,"成功！")
                    }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    private fun requestVideoSign(videoId: String) {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        params.put("video_call_id", videoId)
        KLog.e(null,"ques="+question_id +"uid=" +userBean.uid+"videoid="+videoId)
        sender.getWithTokenOnUI(this, CMRequestType.QXQ_VIDEO_USER_SIGN, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                KLog.e(null,"ques="+Gson().toJson(obj))
                if (obj != null) {
                    var data = obj as QXQVideoSignBean
                    if (data.code == 0) {
//                        ToastUtils.showLong("成功！")
                        connectVideo(data)
                    }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    override fun onResume() {
        super.onResume()
        isOpenVideo = false
    }
    @SuppressLint("CheckResult")
    private fun connectVideo(data: QXQVideoSignBean) {
        val result = data.result
        if (result != null) {
            if (TextUtils.isEmpty(result.video_call_id)
                    || TextUtils.isEmpty(question_id)) {
                ToastUtils.showLong("参数有误" + question_id + "---" + result.video_call_id)
                return
            }
            isOpenVideo = true
            rl_progress.visibility = View.VISIBLE
            Observable.timer(500,TimeUnit.MILLISECONDS)
                    .observeOn(AndroidSchedulers.mainThread())
                    .subscribe {
                        val intent = Intent(this, RTCActivity::class.java)
                        intent.putExtra(Constant.ROOM_ID, question_id)
                        intent.putExtra(Constant.USER_ID, result.stream_uid)
                        intent.putExtra(Constant.QUESTION_UID,userBean.uid)
                        intent.putExtra(Constant.SIGN, result.sign)
                        intent.putExtra(Constant.FROM,1)
                        startActivityForResult(intent, Constant.VIDEO_CLOSE_REQUEST_CODE)
                        rl_progress.visibility = View.GONE
                    }
        }
    }

    private fun getAnswerDetail() {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        rl_progress.visibility = View.VISIBLE
        sender.getWithTokenOnUI(this, CMRequestType.QXQ_VIDEO_CHAT_LIST, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                rl_progress.visibility = View.GONE
                if (obj != null) {
                    var bean = obj as QXQChatBean
                    if(bean.result == null)
                    {
                        resultList = ArrayList()
                    }else{
                        resultList = bean!!.result!!
                    }
                    KLog.json(Gson().toJson(bean))
                    var dis = Observable.just("")
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribe{
                                showView(resultList)
                            }
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
                rl_progress.visibility = View.GONE
            }

        })
    }

    override fun onStart() {
        super.onStart()

    }
    private fun showView(result: ArrayList<QXQChatBean.Message>) {
        //添加问题气泡
        var questionMsg: QXQChatBean.Message = getLeftMessage(questionContent)
        result.add(0, questionMsg)
        chatAapter.setNewData(result)
        rv_content.scrollToPosition(resultList.size - 1)
    }

    private fun getLeftMessage(content: String): QXQChatBean.Message {
        var message = QXQChatBean.Message()
        message.content = content
        message.create_time = (create_time.toLong()).toString()
        message.content_type = "text"
        message.dialog_id = ""
        message.uid = ""
        return message
    }

    @SuppressLint("CheckResult")
    private fun sendMessage(content: String, contType: String) {
       Observable.just("")
               .observeOn(AndroidSchedulers.mainThread())
               .subscribe {
                   var message = QXQChatBean.Message()
                   message.content = content
                   message.content_type = contType
                   message.create_time = (System.currentTimeMillis() / 1000).toString()
                   message.dialog_id = (resultList.size + 1).toString()
                   message.uid = userBean.uid
                   resultList.add(message)
                   chatAapter.notifyDataSetChanged()
                   rv_content.scrollToPosition(resultList.size - 1)
                   sendMessageToServer(content, message,contType)
               }
    }

    private fun sendMessageToServer(content: String, message: QXQChatBean.Message,type:String) {
        var params = HashMap<String, String>()
        params.put("question_id", question_id)
        params.put("uid", userBean.uid)
        params.put("content", content)
        params.put("content_type", type)
        sender.postWithTokenOnUI(this, CMRequestType.QXQ_SEND_MESSAGE, params, AppConstants.SOURCE_SECRET, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj != null) {
                    KLog.json(Gson().toJson(obj))
                    var result = obj as BaseEntity
                    if (result.code == 0) {
                        message.create_time = (System.currentTimeMillis() / 1000).toString()
                        message.sendStatus = 1
                    } else {
                        message.sendStatus = 2
                    }
                    chatAapter.notifyDataSetChanged()
                }
                rl_progress.visibility = View.GONE
            }

            override fun onFail(tag: String?, code: Int, msg: String?, headers: Array<out Header>?) {
                message.sendStatus = 2
                chatAapter.notifyDataSetChanged()
                rl_progress.visibility = View.GONE
            }

        })
    }

    override fun onDestroy() {
        super.onDestroy()
        PushManager.getInstance().removeMsgListener(this@QXQChatActivity)
        EventBus.getDefault().unregister(this)
        isQXQChatShow = true
    }

    override fun onClick(v: View?) {
        when (v!!.id) {
            R.id.bt_send -> {
                content = et_chat.text.toString().trim()
                KeyboardUtils.hideSoftInput(this)
                et_chat.clearFocus()
                if (TextUtils.isEmpty(content))
                {
                    ToastUtils.showLong("请输入内容！")
                    return
                }
                sendMessage(content, "text")
                et_chat.setText("")

                rv_content.scrollToPosition(resultList.size - 1)
            }
            R.id.iv_add_image -> {
                KeyboardUtils.hideSoftInput(this)
                AndPermission.with(this)
                        .runtime()
                        .permission(Permission.Group.STORAGE)
                        .onGranted {
                            toSelectImage()
                        }.start()
            }
            R.id.iv_back->{
                finish()
            }
            R.id.iv_add_zhuan->{
                if ("T"!=isSolved)
                {
                    return
                }
                val intent = Intent(applicationContext, PushQXQCloseFeedbackActivity::class.java)
                intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK or Intent.FLAG_ACTIVITY_CLEAR_TOP
                intent.putExtra("question_id", question_id)
                intent.putExtra("question_content", questionContent)
                startActivity(intent)
            }
        }
    }

    private fun sendImg() {
        rl_progress.visibility = View.VISIBLE
        sender.postImgToUpy(this, CMRequestType.POST_IMG_TO_UPY, currPicPath, object : CMJsonCallback {
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                if (obj != null) {
                    var entity = obj as UPYunEntity
                    if (entity.getCode() != 200) {
                        onFail(tag, -1, null, null)
                        return
                    }
                    val url = AppConstants.UPYUN_UPLOAD_URL_BASE + entity.getUrl() /*+"!150x150"*/
                    sendMessage(url,"image")
                }else{
                    rl_progress.visibility = View.GONE
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
                rl_progress.visibility = View.GONE
            }

        })
    }

    private fun sendImgMsgToServer() {
        //发送图片消息到服务器

    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when(requestCode)
        {
            CODE_GALLERY->{
                if(data == null)
                {
                    return
                }
                currPicPath = BitmapTools.resolvePhotoFromIntent(this, data)
                if (TextUtils.isEmpty(currPicPath)) {
                    ToastUtils.showLong(null, "请尝试选择系统相册打开！")
                    return
                }
                sendImg()
            }
            Constant.VIDEO_CLOSE_REQUEST_CODE->{
                if(resultCode == Constant.VIDEO_CLOSE_RESPONSE_CODE)
                {
                   isOpenVideo = false
                   var a =  Observable.just("")
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribe {
                                closeVideo(videoId)
                            }
                    Observable.timer(2000, TimeUnit.MILLISECONDS)
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribe{
//                                ShowDialog.showQXQCloseDialog(this) {
//                                    closeVideoFeedback()
//                                }
                                getAnswerDetail()
                            }
                }
            }
        }


    }
    //关闭视频回调
    private fun closeVideoFeedback() {


    }
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onFeedbackEvent(event: FeedbackMessage)
    {
        getQuestionDetail()
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onMessageEvent(event: VideoCloseMessage?) {
        isOpenVideo = false
        if (ad !== null && ad!!.isShowing)
        {
            ad!!.dismiss()
        }
    }

    private fun toSelectImage() {
        /*if(!Environment.getExternalStorageDirectory().canRead()
					|| !Environment.getExternalStorageDirectory().canWrite()) {
				ToastUtils.toast(this, "您的手机暂时无法获取图片,请尝试在系统设置中设置相关权限");
				return;
			}*/
//                ImageCreator.dispatchGalleryIntent(ChatActivity.this, CODE_GALLERY);
        BitmapTools.openPic(this@QXQChatActivity, CODE_GALLERY)
    }

    override fun havePush(pushBean: PushBean?) {
        KLog.e(null,"havePush---------------------")
        if (pushBean == null)
        {
            return
        }
        if (pushBean.from_source != "qxq_wx_small")
        {
            return
        }


        //用户挂断视频
        if (pushBean.sub_type == 11)
        {
            if (toOtherDialog!==null)
            {
                if (toOtherDialog!!.isShowing)
                {
                    toOtherDialog!!.dismiss()
                }
            }
            if (ad!==null)
            {
                if ( ad!!.isShowing()) {
                    ToastUtils.showLong("用户已挂断")
                    if (ad!!.isShowing()) {
                        ad!!.dismiss()
                    }

                }
            }
            EventBus.getDefault().post(VideoCloseMessage())
            refuseVideo(pushBean.video_call_id,pushBean.question_id)
        }

        if (!isOpenVideo && pushBean.sub_type == 10)
        {
            //获取聊天内容
            getAnswerDetail()
            if ( pushBean.question_id == question_id)
            {
                //获取视频新资讯消息
                getVideoMsg()
            }else{
                toOtherChatPage(pushBean.video_call_id,pushBean.question_id)

            }
        }

    }
    var toOtherDialog :AlertDialog?=null
    private fun toOtherChatPage(video_call_id:String,question_id:String) {
        val str = arrayOf("提示", "收到其他用户的视频咨询请求，去到他的页面接受咨询？", "前往接通","暂不接受")
         toOtherDialog = ShowDialog.showSelectDialog(str, this, object : OnDialogClick() {
            override fun onClick(dialogView: AlertDialog?, view: View?, index: Int) {
                if (index == 0) {
                    //挂断视频请求
                    refuseVideo(video_call_id, question_id)
                    dialogView!!.dismiss()
                    return
                }
                //当前不是和目标用户的聊天页面，进入到目标页面
                var intent = Intent(this@QXQChatActivity, QXQChatActivity::class.java)
                intent.putExtra("question_id", question_id)
                intent.putExtra("request_video_call_id", video_call_id)
                this@QXQChatActivity.startActivity(intent)
                this@QXQChatActivity.finish()
                dialogView!!.dismiss()
            }

        })
    }
    /**
     * 点击空白处隐藏键盘
     */
//    override fun dispatchTouchEvent(ev: MotionEvent): Boolean {
//        if (ev.action == MotionEvent.ACTION_DOWN) {
//            val v = currentFocus
//            if (isShouldHideKeyboard(v, ev)) {
//                KeyboardUtils.hideSoftInput(this)
//            }
//        }
//        return super.dispatchTouchEvent(ev)
//    }
//
//    // Return whether touch the view.
//    private fun isShouldHideKeyboard(v: View, event: MotionEvent): Boolean {
//        if (v is EditText) {
//            val l = intArrayOf(0, 0)
//            v.getLocationOnScreen(l)
//            val left = l[0]
//            val top = l[1]
//            val bottom = top + v.getHeight()
//            val right = left + v.getWidth()
//            return !(event.rawX > left && event.rawX < right && event.rawY > top && event.rawY < bottom)
//        }
//        return false
//    }

}