package com.bcb.master.ui

import android.annotation.SuppressLint
import android.os.Bundle
import android.support.design.widget.TabLayout
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentTransaction
import android.util.Log
import android.view.View
import com.bcb.master.R
import kotlinx.android.synthetic.main.activity_question_history.*
import kotlinx.android.synthetic.main.activity_title_white.*


/**

 * @author bcb
 * @date 2017/11/27
 */

class QuestionHistoryList : BaseActivity(), View.OnClickListener {
    lateinit var mFragment :Fragment
    var mFragmentPos :Int =0;
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_question_history)
        initView()
    }

    lateinit var fragmentTransaction: FragmentTransaction

    lateinit var questionTxtAnswerList: QuestionTxtAnswerList
    var questionVideoAnswerList: QuestionVideoAnswerList?=null

    fun initView() {
        tv_title.setText("答题量")
        iv_back.setOnClickListener(this)
        fragmentTransaction = supportFragmentManager.beginTransaction()
        questionTxtAnswerList = QuestionTxtAnswerList()
        fragmentTransaction.add(R.id.fl_question_layout, questionTxtAnswerList,"text_answer")
        fragmentTransaction.commitAllowingStateLoss()
        mFragment = questionTxtAnswerList
        auto_tab_layout.getTabAt(0)!!.select()
        auto_tab_layout.addOnTabSelectedListener(object :TabLayout.OnTabSelectedListener{
            override fun onTabReselected(p0: TabLayout.Tab?) {

            }

            override fun onTabUnselected(p0: TabLayout.Tab?) {
            }

            override fun onTabSelected(p0: TabLayout.Tab?) {
                when(p0!!.position)
                {
                    0->{
                        if (questionTxtAnswerList == null)
                        {
                            questionTxtAnswerList = QuestionTxtAnswerList()
                        }
                        mFragmentPos = 0
                        switchContent(mFragment,questionTxtAnswerList,"text_answer")
                    }
                    1->{
                        if (questionVideoAnswerList == null)
                        {
                            questionVideoAnswerList = QuestionVideoAnswerList()
                        }
                        mFragmentPos = 1
                        switchContent(mFragment, questionVideoAnswerList!!,"video_answer")

                    }
                }
            }

        })
    }
    fun toNextFragment(postion:Int){
        when(postion)
        {
            0->{
                if (questionTxtAnswerList == null)
                {
                    questionTxtAnswerList = QuestionTxtAnswerList()
                }
                mFragmentPos = 0
                switchContent(mFragment,questionTxtAnswerList,"text_answer")
            }
            1->{
                if (questionVideoAnswerList == null)
                {
                    questionVideoAnswerList = QuestionVideoAnswerList()
                }
                mFragmentPos = 1
                switchContent(mFragment, questionVideoAnswerList!!,"video_answer")

            }
        }
    }
    override fun onClick(v: View?) {
        when (v!!.id) {
            R.id.iv_back ->{
                finish()
            }
        }
    }

    @Synchronized
    private fun switchContent(from: Fragment?, to: Fragment,tag:String) {
        Log.d(QuestionActivity.TAG, "switchContent")
        if (null == from || null == to) {
            Log.d(QuestionActivity.TAG, "switchContent null fragment")
            return
        }
        if (mFragment !== to) {
            Log.d(QuestionActivity.TAG, "mFragment is not target fragment, is added:" + to.isAdded)
            mFragment = to
            if (supportFragmentManager.findFragmentByTag(tag)!=null)
            {
                supportFragmentManager.beginTransaction().hide(from).show(to).commitAllowingStateLoss() // 隐藏当前的fragment，显示下一个

            }else{// 先判断是否被add过
                supportFragmentManager.beginTransaction().hide(from).add(R.id.fl_question_layout, to,tag).commitAllowingStateLoss() // 隐藏当前的fragment，add下一个到Activity中
            }

        } else {
            Log.d(QuestionActivity.TAG, "mFragment is target fragment")
        }
        Log.d(QuestionActivity.TAG, "switchContent end-----")
    }

    override fun onRestoreInstanceState(savedInstanceState: Bundle) {
        mFragmentPos = savedInstanceState.getInt("position");
        toNextFragment(mFragmentPos)
        super.onRestoreInstanceState(savedInstanceState)

    }
    @SuppressLint("MissingSuperCall")
    override fun onSaveInstanceState(outState: Bundle) {
//        super.onSaveInstanceState(outState)
//        super.onSaveInstanceState(outState)
        outState.putInt("postion",mFragmentPos)
    }
}
