package com.bcb.master.utils

import android.app.Application
import android.content.Context
import android.os.Environment
import android.text.TextUtils
import com.bcb.carmaster.im.ImClient
import com.bcb.master.MasterApplication
import com.loopj.http.data.Master
import com.nostra13.universalimageloader.core.ImageLoader
import com.nostra13.universalimageloader.utils.StorageUtils
import org.litepal.crud.DataSupport
import org.litepal.util.Const
import java.io.File
import java.math.BigDecimal


/**
* Created by bcb on 2018/2/28.
*/
class CacheUtils(ctx:Context) {
    companion object {
        fun clearCache(ctx: Context){
                val externalCacheDir = ctx.cacheDir
                var size = getFolderSize(externalCacheDir)

            val externalCacheDir1 = ctx.externalCacheDir
            var externalSize = getFolderSize(externalCacheDir1)
            val externalFilesDir_m = ctx.getExternalFilesDir(Environment.DIRECTORY_MUSIC)
            var externalSize_m = getFolderSize(externalFilesDir_m)
            val externalFilesDir_p = ctx.getExternalFilesDir(Environment.DIRECTORY_PICTURES)
            var externalSize_p = getFolderSize(externalFilesDir_p)
            val externalFilesDir_d = ctx.getExternalFilesDir(Environment.DIRECTORY_DOWNLOADS)
            var externalSize_d = getFolderSize(externalFilesDir_d)
            val cacheDirectory = StorageUtils.getCacheDirectory(ctx)
            var imageloadercachesize = getFolderSize(cacheDirectory)
            val externalFilesDir_baidu = ctx.getExternalFilesDir("baidu")
            var externalFilesDir_baidu_size = getFolderSize(externalFilesDir_baidu)

            var allCacheSize = size+externalSize+externalSize_m+externalSize_p+externalSize_d+imageloadercachesize+externalFilesDir_baidu_size
            LogUtil.e("cacheSize: = ",externalCacheDir.absolutePath+"---"+getFormatSize(allCacheSize*1.00))
            deleteFile(externalCacheDir.absolutePath)
            deleteFile(externalCacheDir1.absolutePath)
            deleteFile(externalFilesDir_m.absolutePath)
            deleteFile(externalFilesDir_p.absolutePath)
            deleteFile(externalFilesDir_d.absolutePath)
            deleteFile(cacheDirectory.absolutePath)
            deleteFile(externalFilesDir_baidu.absolutePath)
            ImageLoader.getInstance().clearDiskCache()
            //删除数据库所有表数据
            ImClient.getInstance().deleteAll()

        }

        fun getFolderSize(file: File): Long {
            var size: Long = 0
            try {
                val fileList = file.listFiles()
                for (i in fileList.indices) {
                    // 如果下面还有文件
                    if (fileList[i].isDirectory()) {
                        size = size + getFolderSize(fileList[i])
                    } else {
                        size = size + fileList[i].length()
                    }
                }
            } catch (e: Exception) {
                e.printStackTrace()
            }

            return size
        }

        fun getFormatSize(size: Double): String {
            val kiloByte = size / 1024
            if (kiloByte < 1) {
                return size.toString() + "Byte"
            }

            val megaByte = kiloByte / 1024
            if (megaByte < 1) {
                val result1 = BigDecimal(java.lang.Double.toString(kiloByte))
                return result1.setScale(2, BigDecimal.ROUND_HALF_UP)
                        .toPlainString() + "KB"
            }

            val gigaByte = megaByte / 1024
            if (gigaByte < 1) {
                val result2 = BigDecimal(java.lang.Double.toString(megaByte))
                return result2.setScale(2, BigDecimal.ROUND_HALF_UP)
                        .toPlainString() + "MB"
            }

            val teraBytes = gigaByte / 1024
            if (teraBytes < 1) {
                val result3 = BigDecimal(java.lang.Double.toString(gigaByte))
                return result3.setScale(2, BigDecimal.ROUND_HALF_UP)
                        .toPlainString() + "GB"
            }
            val result4 = BigDecimal(teraBytes)
            return result4.setScale(2, BigDecimal.ROUND_HALF_UP).toPlainString() + "TB"
        }


        fun deleteFile(filePath: String) {
            if (!TextUtils.isEmpty(filePath)) {
                try {
                    val file = File(filePath)
                    if (file.isDirectory) {// 如果下面还有文件
                        val files = file.listFiles()
                        for (i in files.indices) {
                            deleteFile(files[i].absolutePath)
                        }
                    }

                    if (!file.isDirectory) {// 如果是文件，删除
                        file.delete()
                    } else {// 目录
                        if (file.listFiles().size == 0) {// 目录下没有文件或者目录，删除
                            file.delete()
                        }
                    }

                } catch (e: Exception) {
                    // TODO Auto-generated catch block
                    e.printStackTrace()
                }

            }
        }

    }


}