package com.bcb.master.utils

import android.app.Activity
import android.content.Context
import com.bcb.master.MasterApplication
import com.bcb.master.common.AdvertismentTipDlg
import com.bcb.master.model.UserBean
import com.nostra13.universalimageloader.core.DisplayImageOptions
import com.nostra13.universalimageloader.core.assist.ImageScaleType
import com.nostra13.universalimageloader.core.display.RoundedBitmapDisplayer

private val options = DisplayImageOptions.Builder()
        .cacheInMemory(true)                        // 设置下载的图片是否缓存在内存中
        .cacheOnDisk(true)                            // 设置下载的图片是否缓存在SD卡中
        .displayer(RoundedBitmapDisplayer(8))    // 设置成圆角图片
        .imageScaleType(ImageScaleType.EXACTLY_STRETCHED)//设置图片等比缩放
        .build()


fun can_answer_normal(ctx: Context,showdialog : Boolean):Int{
    val result  = can_answer(ctx,true,showdialog)
    if(result == -1)
    {
        ToastUtils.toast(ctx,"用户信息不完整,请重新登录账号!")
        return 0
    }
    return result

}
fun can_answer(ctx: Context, isNormal: Boolean, showdialog: Boolean):Int{
    val userBean = MasterApplication.getUserBean(ctx) ?: return -1
    val grade_permissions = userBean.grade_permissions ?: return -1
    var permission:UserBean.GradePermissionsBean.BaseQuestionBean
    permission = if (isNormal) {
        grade_permissions.normal_questions

    }else{
        grade_permissions.paid_questions
    }
    val can_answer = permission.can_answer
    return if (can_answer == 0) {
        if (showdialog) {
            val dlg = AdvertismentTipDlg<UserBean.GradePermissionsBean.BaseQuestionBean>()
            dlg.show(ctx as Activity, permission,options)
        }
        0
    }else{
        1
    }
}

fun can_answer_paid(ctx: Context,showdialog : Boolean):Int{
    val result = can_answer(ctx, false, showdialog)
    if(result == -1)
    {
        ToastUtils.toast(ctx,"用户信息不完整,请重新登录账号!")
        return 0
    }
  return result

}